]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
- compress docs: if man link is in other section than current, we need to preserve...
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# $Revision$, $Date$
2# vim:ts=4 sw=4 noet ft=spec
3#
4# PLD Linux rpm macros.
5# <http://www.pld-linux.org/>
6
7# can be used by builder script to check for version
8%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
9
10%epoch 0
11%x8664 x86_64 amd64 ia32e
12%arm armv3l armv4b armv4l armv5teb armv5tel
13
14# kernel compiler
15%kgcc %{__cc}
16%kgcc_package gcc
17
18# compiler version
19%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
20%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
21
22%__rm /bin/rm --interactive=never
23
24# Build system path macros.
25%__autoconf autoconf %{?debug:-Wall}
26%__automake automake -a -c -f --foreign
27%__autopoint autopoint --force
28
29# add parallel build flags: -jN
30#
31# if you want to disable parallel build do:
32# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
33#
34%__make /usr/bin/make %{?_smp_mflags}
35%__scons /usr/bin/scons %{?_smp_mflags}
36%__waf /usr/bin/waf %{?_smp_mflags}
37%__cmake /usr/bin/cmake
38
39%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
40 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
41
42%__gettextize { \
43 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
44 gettextize --copy --force --no-changelog; \
45 else \
46 gettextize --copy --force --no-changelog --intl; \
47 fi; \
48 if [ ! -f po/Makevars ]; then \
49 cp -f po/Makevars{.template,}; \
50 fi; \
51}
52
53%__glib_gettextize glib-gettextize --copy --force
54%__gnome_doc_common gnome-doc-common --copy
55%__gnome_doc_prepare gnome-doc-prepare --copy --force
56%__gtkdocize gtkdocize --copy
57%__intltoolize intltoolize --copy --force
58%__libtoolize libtoolize --copy --force --install
59
60# topdir is where builder script lives,
61# fallback to old style if SPECS/SOURCES dirs were found.
62%_topdir %{expand:%%global _topdir %(
63 if [ -d SPECS -a -d SOURCES ]; then
64 # old style rpmdir: in topdir
65 pwd
66 elif [ -d ../SPECS -a -d ../SOURCES ]; then
67 # old style rpmdir: in subdir
68 cd ..; pwd
69 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
70 # if old style rpm dir exist, go with it
71 echo $HOME/rpm; \
72 elif [ -x ../builder -a ! -d ../builder ]; then
73 # relative new style rpmdir: in package dir
74 cd ..; pwd
75 elif [ -x builder -a ! -d builder ]; then
76 # relative new style rpmdir: in packages
77 pwd
78 elif [ -x packages/builder -a ! -d packages/builder ]; then
79 # relative new style rpmdir: packages dir in current dir
80 cd packages; pwd
81 else
82 # fallback to new style rpmdir
83 echo $HOME/rpm/packages
84 fi; \
85)}%_topdir
86
87# if %{_topdir}/SPECS exists, it's old style structure
88%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
89%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
90
91# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
92# if they don't exist assume we are having custom topdir (which is not named as
93# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
94# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
95%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
96%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
97%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
98
99# The number of cvs changelog entries kept when building package.
100%_buildchangelogtruncate 20
101
102%dependencytracking %{nil}
103
104# Relations between package names that cause dependency loops
105# with legacy packages that cannot be fixed. Relations are
106# specified as
107# p>q
108# where package p has a Requires: on something that package q Provides:
109#
110# XXX Note: that there cannot be any whitespace within the string "p>q",
111# and that both p and q are package names (i.e. no version/release).
112%_dependency_whiteout %{nil}
113
114#-----------------------------------------------------------------
115#
116# (re)definition of %{rpm*flags} with %filterout_* support
117# BuildRequires: awk
118# BuildRequires: rpmbuild(macros) >= 1.315
119#
120# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
121# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
122# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
123# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
124# %rpmldflags = %optldflags - %filterout_ld
125#
126# Regular expressions are supported, but to avoid some character be treated
127# as regular expression it must be escaped twice.
128
129%filter_out \
130 for (i = 1; i in I; i++) { A=0; \
131 for (f in F) { \
132 if (I[i] ~ "^" F[f] "$") A=1; \
133 }; \
134 if (!A) printf(I[i] FS); \
135 }
136
137%rpmcflags %(awk 'BEGIN {
138 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
139 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
140 %{filter_out}
141}')
142
143%rpmcxxflags %(awk 'BEGIN {
144 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
145 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
146 %{filter_out}
147}')
148
149%rpmcppflags %(awk 'BEGIN {
150 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
151 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
152 %{filter_out}
153}')
154
155%rpmldflags %(awk 'BEGIN {
156 split("%{?optldflags}",I);
157 split("%{?filterout_ld}",F)
158 %{filter_out}
159}')
160
161# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
162# but, don't use it, better use gcc as linker
163%ld_rpmldflags %(awk 'BEGIN {
164 split("%{rpmldflags}",F);
165 for (f in F) {
166 s = F[f];
167 if (s ~ /^-Wl,/) {
168 s = substr(s,5);
169 gsub(/,/," ",s);
170 };
171 printf(s FS);
172 };
173}')
174
175#-----------------------------------------------------------------
176#
177# Generate a command which cleans environment, leaving only the
178# most important variables.
179# If any spec requires any additional environment it should
180# redefine %_preserve_env in following manner:
181#
182# # ADDITIONAL_VAR is required because [a good reason here]
183# %define _preserve_env ADDITIONAL_VAR
184
185%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
186
187# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
188%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
189 split("%{?_preserve_env}", P);
190 for (i in P) {
191 p = P[i];
192 if (!ENVIRON[p] || d[p]) {
193 continue;
194 }
195 d[p] = 1;
196 split(ENVIRON[p], V, "");
197 val = p "=";
198 for (j = 1; j in V; j++) {
199 v = V[j];
200 if (v == q)
201 v = qq;
202 else if (v == "\\"")
203 v = q2q;
204 else if (v == "\\\\")
205 v = "\\\\\\\\";
206 else
207 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
208 val = val "" v;
209 }
210 printf(val " ");
211 }
212}')
213
214#-----------------------------------------------------------------
215%configure2_13 { \
216 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
217 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
218 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
219 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
220 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
221 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
222 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
223 %{?__cc:CC="%{__cc}" ; export CC ; } \
224 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
225 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
226 --host=%{_target_platform} \
227 --prefix=%{_prefix} \
228 --exec-prefix=%{_exec_prefix} \
229 --bindir=%{_bindir} \
230 --sbindir=%{_sbindir} \
231 --sysconfdir=%{_sysconfdir} \
232 --datadir=%{_datadir} \
233 --includedir=%{_includedir} \
234 --libdir=%{_libdir} \
235 --libexecdir=%{_libexecdir} \
236 --localstatedir=%{_localstatedir} \
237 --sharedstatedir=%{_sharedstatedir} \
238 --mandir=%{_mandir} \
239 --infodir=%{_infodir} \
240 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
241 %{dependencytracking} \
242}
243
244%cmake \
245%{?__cc:CC="%{__cc}"} \\\
246%{?__cxx:CXX="%{__cxx}"} \\\
247CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
248%{__cmake} \\\
249 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
250 -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
251 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
252 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
253 -DINCLUDE_INSTALL_DIR:PATH=%{_includedir} \\\
254 -DLIB_INSTALL_DIR:PATH=%{_libdir} \\\
255 -DSHARE_INSTALL_PREFIX:PATH=%{_datadir} \\\
256 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
257 -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG}" \\\
258 -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
259 -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
260 -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
261 -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
262 -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
263%if "%{_lib}" == "lib64" \
264 -DLIB_SUFFIX=64 \\\
265%endif \
266 -DBUILD_SHARED_LIBS:BOOL=ON \\\
267%{nil}
268
269%scons { \
270%{__scons} \
271 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
272 CFLAGS="${CFLAGS:-%rpmcflags}" \
273 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
274 FFLAGS="${FFLAGS:-%rpmcflags}" \
275 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
276 %{?__cc:CC="%{__cc}"} \
277 %{?__cxx:CXX="%{__cxx}"} \
278 libsuffix=%{_lib} \
279 prefix=%{_prefix} \
280}
281
282# waf. see waf.spec
283%waf { \
284CC="%{__cc}" \
285CXX="%{__cxx}" \
286CPP="%{__cpp}" \
287CFLAGS="%{rpmcflags}" \
288CXXFLAGS="%{rpmcxxflags}" \
289%{__waf} \
290}
291
292#----------------------------------------------------------------
293#%configure_cache 0
294%configure_cache_file %{buildroot}.configure.cache
295
296%configure {./configure \
297 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
298 CFLAGS="${CFLAGS:-%rpmcflags}" \
299 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
300 FFLAGS="${FFLAGS:-%rpmcflags}" \
301 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
302 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
303 %{?__cc:CC="%{__cc}"} \
304 %{?__cxx:CXX="%{__cxx}"} \
305 --host=%{_target_platform} \
306 --build=%{_target_platform} \
307 --prefix=%{_prefix} \
308 --exec-prefix=%{_exec_prefix} \
309 --bindir=%{_bindir} \
310 --sbindir=%{_sbindir} \
311 --sysconfdir=%{_sysconfdir} \
312 --datadir=%{_datadir} \
313 --includedir=%{_includedir} \
314 --libdir=%{_libdir} \
315 --libexecdir=%{_libexecdir} \
316 --localstatedir=%{_localstatedir} \
317 --sharedstatedir=%{_sharedstatedir} \
318 --mandir=%{_mandir} \
319 --infodir=%{_infodir} \
320 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
321 %{dependencytracking} \
322 %{?configure_cache:--cache-file=%{configure_cache_file}} \
323}
324
325# Simple macros to simplify adding bconded options to configure scripts.
326# Each macro requires bcond name and accepts optional option name, if option
327# isn't specified bcond name is used as option name. Options returning
328# --with and --enable also allow third argument which will be added as value
329# ( --with-option=value or --enable-option=value ) in case or positive
330# condition, but won't be added otherwise ( nothing or just --disable-option ).
331
332# Requirements:
333# BuildRequires: rpmbuild(macros) >= 1.527
334
335# Usage example:
336# %{__enable bcond} - returns --enable-bcond iff build condition is set
337# %{__disable bcond option} - returns --enable-option iff bcond is not set
338# %{__enable_disable bcond option value} - returns --enable-option=value if
339# bcond is set, returns --disable-option otherwise
340
341# expand bconds to --enable-something and --disable-something
342%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
343%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
344%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
345
346# same as above, but condition inverted
347%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
348%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
349%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
350
351# expand bconds to --with-something and --without-something
352%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
353%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
354%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
355
356# same as above, but condition inverted
357%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
358%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
359%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
360
361#-----------------------------------------------------------------
362
363# overload to insert debuginfo package
364%prep \
365%if 0%{?_enable_debug_packages}\
366%{debug_package}\
367%endif\
368%%prep\
369%{nil}
370
371# Location of autoconf macros
372%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
373
374# Location of omf files
375%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
376
377# Location of pkgconfig files
378%_pkgconfigdir /usr/%{_lib}/pkgconfig
379# noarch pkgconfig files
380%_npkgconfigdir /usr/share/pkgconfig
381
382# Location of desktop files
383%_desktopdir /usr/share/applications
384%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
385
386# Location of pixmaps for applnk/desktop files
387%_pixmapsdir /usr/share/pixmaps
388
389# Location of themable icons for applnk/desktop files
390%_iconsdir /usr/share/icons
391
392# Location of fonts directories
393%_fontsdir /usr/share/fonts
394
395# Location of Gtk and associated libraries documentation
396%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
397
398# Location of KDE documentation
399%_kdedocdir %{_defaultdocdir}/kde/HTML
400
401# unsermake script
402%__unsermake /usr/share/unsermake/unsermake
403
404# Current date
405%date %(LC_ALL=C date +"%a %b %d %Y")
406
407# Example files, programs, scripts...
408%_examplesdir /usr/src/examples
409
410# Alternative kernel type/version
411%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
412
413# The directory holding Linux kernel sources
414%_kernelsrcdir /usr/src/linux%{_alt_kernel}
415
416# SysV-style initscripts dir
417%_initddir /etc/rc.d/init.d
418
419# If non-empty "debug" macro defined, add "dbg" suffix to release number
420%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
421
422# Bootstrap release macros.
423# Usage:
424# %bcond_with bootstrap
425# Release: %{bootstrap_release 1}
426#
427# Package will have release 1 if built normally,
428# and release 0.zzz.bootstrap if built with bootstrap
429%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
430
431# -n drm to generate kernel%{_alt_kernel}-drm dependency
432%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
433%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
434%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
435
436# -s post to generate Requires(post) dependency
437%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
438%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
439%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
440
441# Requires name = version-release
442%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
443# Requires: name = version
444%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
445# Requires: name = version (version based on querying package %2)
446%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
447
448# Requires: name >= version
449%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
450# Requires: name >= version (version based on querying package %2)
451%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
452
453%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
454
455# kernel version-release handling
456%__kernel_ver %{expand:%%global __kernel_ver %( \\
457 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
458 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
459 echo ${Z:-ERROR}; \\
460)}%__kernel_ver
461
462%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
463%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
464%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
465%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
466
467# `uname -r` to be used in @release field
468%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
469
470# sgml macros
471%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
472%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
473%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
474%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
475%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
476%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
477%docbook_sgmlcat_fix() { for l in \
478'' \
479' -- default decl --' \
480'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
481' -- hacks for opensp --' \
482'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
483'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
484'' \
485; do echo $l; done >> %1 \
486}
487
488# vim - "
489
490# minimum file size needed for compressed documents.
491# just smaller files than this get larger when compressed.
492# some stats:
493# - 0 byte file compressed was 25 bytes .gz
494# - 39 byte file was compressed as 57
495# - with test/test.spec@man 158 byte file was compressed also 158
496%_min_compress_bytes 159
497
498#-----------------------------------------------------------------
499# find and gzip all files in %{_mandir} and %{infodir}
500#
501# Requires: xargs, find
502#
503#%no_install_post_compress_docs 1
504%__spec_install_post_compress_docs { \
505%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
506 %{!?debug:set +x}; \
507 for i in /usr/share/man /usr/X11R6/man; do \
508 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
509 echo "Compress man pages: $i"; \
510 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
511 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
512 find $RPM_BUILD_ROOT$i -type l | while read a; do \
513 m=$(readlink "$a"); \
514 rm -f $a; \
515 l=${m#/usr/share/man/}; \
516 l=${l#/usr/X11R6/man/}; \
517 echo ".so $l" > $a; \
518 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
519 done; \
520 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
521 fi; \
522 done; \
523 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
524 echo "Compress info pages: %{_infodir}"; \
525 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
526 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
527 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
528 fi; \
529}; __spec_install_post_compress_docs } }
530
531#-----------------------------------------------------------------
532# Strip executable binaries and shared object files
533#
534# Requires: find, awk, strip, cut, xargs
535#
536# Special macros which affect this process:
537#%no_install_post_strip 1 # disable stripping at all
538#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
539#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
540#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
541#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
542#
543%__spec_install_post_strip {%{!?debug: \
544%{!?no_install_post_strip:__spec_install_post_strip() { \
545if [ -d "$RPM_BUILD_ROOT" ]; then \
546 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
547 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
548 if [ "$modulelist" ]; then \
549 modulecount=$(echo "$modulelist" | wc -l); \
550 printf "Stripping %d kernel modules..." $modulecount; \
551 echo "$modulelist" | xargs -l512 chmod u+w; \
552 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
553 echo "DONE"; \
554 fi; \
555 fi; \
556 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
557 if [ -n "$filelist" ]; then \
558 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
559 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
560 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
561 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
562 if [ -n "$elfexelist" ]; then \
563 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
564 echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
565 echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
566 echo "DONE"; \
567 fi; \
568 if [ -n "$elfsharedlist" ]; then \
569 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
570 echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
571 echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
572 echo "DONE"; \
573 fi; \
574 if [ -n "$archiveslist" ]; then \
575 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
576 echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
577 echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
578 echo "DONE"; \
579 fi; \
580 fi; \
581 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
582 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
583 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
584 if [ -n "$filelist_all" ]; then \
585 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
586 chmod u+w $filelist_all; \
587 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
588 echo "DONE"; \
589 fi; \
590 if [ -n "$filelist_unneeded" ]; then \
591 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
592 chmod u+w $filelist_unneeded; \
593 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
594 echo "DONE"; \
595 fi; \
596 if [ -n "$filelist_debug" ]; then \
597 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
598 chmod u+w $filelist_debug; \
599 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
600 echo "DONE"; \
601 fi; \
602fi; }; __spec_install_post_strip } } }
603
604#-----------------------------------------------------------------
605# remove all RPATH from executable binaries and shared object files
606#
607# Requires: find, awk, cut, xargs, chrpath, uname
608#
609# Special macros which affect this process
610#%no_install_post_chrpath 1 # disable chrpath at all
611#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
612#
613%__spec_install_post_chrpath {%{!?debug: \
614%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
615if [ -d "$RPM_BUILD_ROOT" ]; then \
616 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
617 if [ -n "$files" ]; then \
618 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
619 fi; \
620 if [ -n "$objs" ]; then \
621 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
622 echo "$objs" | \
623 while read file; do \
624 rpath= ; \
625 chmod u+w "$file"; \
626 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
627 case $dir in \
628 '$ORIGIN' ) \
629 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
630 else rpath="$rpath:$dir" ; fi ; \
631 continue ; \
632 ;; \
633 esac ; \
634 newdir=$(readlink -m "$dir"); \
635 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
636 case $dir in \
637 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
638 echo "remove-rpath: $dir in $file"; \
639 ;; \
640 * ) \
641 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
642 else rpath="$rpath:$dir" ; fi ; \
643 ;; \
644 esac ; \
645 done ; \
646 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
647 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
648 done; \
649 fi; \
650fi; }; __spec_install_post_chrpath } } }
651
652# vim: "
653
654#-----------------------------------------------------------------
655# Find all shared object files with unresolved symbols. Warn
656# and terminate if any found (termination can be turned off by define).
657#%no_install_post_check_so 1
658#%skip_post_check_so libwithunresolvedok.so.*
659#
660# NOTE: define skip_post_check_so only if such library really requires
661# unresolved symbols and always leave a comment why it is required:
662# # executable provides symbols foo, bar for those libraries:
663# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
664#
665%__spec_install_post_check_so { \
666__spec_install_post_check_so() { \
667 fail=0; \
668 printf "Searching for shared objects with unresolved symbols..."; \
669 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
670 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
671 done ; \
672 echo " DONE"; \
673 %{!?no_install_post_check_so:return $fail;} \
674}; __spec_install_post_check_so }}
675
676#-----------------------------------------------------------------
677# Find and gzip all kernel modules
678#
679# Requires: find
680#
681#%no_install_post_compress_modules 1
682%__spec_install_post_compress_modules { \
683%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
684 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
685 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
686 if [ "$q" ]; then \
687 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
688 echo "$q" | xargs -r %{__gzip} -9nf; \
689 echo "DONE"; \
690 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
691 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
692 fi; \
693 fi; \
694}; __spec_install_post_compress_modules } }
695
696# Remove common Perl files we don't package
697%__spec_install_post_perl_clean {\
698%{!?no_install_post_perl_clean: \
699%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
700} }
701
702#-----------------------------------------------------------------
703# Update GConf2 schemas
704#
705# Requires: GConf2
706#
707%gconf_schema_install() \
708 umask 022; \
709 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
710 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
711%{nil}
712
713%gconf_schema_uninstall() \
714if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
715 umask 022; \
716 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
717 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
718fi; \
719%{nil}
720
721#-----------------------------------------------------------------
722# Update desktop MIME database
723# requires: desktop-file-utils
724%update_desktop_database() {{ \
725 umask 022; \
726 /usr/bin/update-desktop-database -q; \
727};} \
728%{nil}
729
730%update_desktop_database_post %update_desktop_database
731
732%update_desktop_database_postun() {{ \
733if [ "$1" = "0" ]; then \
734 %update_desktop_database \
735fi; \
736};} \
737%{nil}
738
739#-----------------------------------------------------------------
740# Update shared MIME info database
741# requires: shared-mime-info
742#
743%update_mime_database() {{ \
744 umask 022; \
745 /usr/bin/update-mime-database %{_datadir}/mime; \
746};} \
747%{nil}
748
749#-----------------------------------------------------------------
750# Update icon cache
751# BuildRequires: rpmbuild(macros) >= 1.596
752# Requires: hicolor-icon-theme
753#
754%update_icon_cache() {{ \
755 %{!?1:%{error:%{0}: Required theme name missing}} \
756 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
757 umask 022; \
758 touch --no-create %{_iconsdir}/%1; \
759 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
760 fi; \
761};} \
762%{nil}
763
764#-----------------------------------------------------------------
765# Update scrollkeeper database
766# requires: scrollkeeper
767#
768%scrollkeeper_update_post() \
769 /usr/bin/scrollkeeper-update -q; \
770%{nil}
771
772%scrollkeeper_update_postun() \
773if [ "$1" = "0" ]; then \
774 /usr/bin/scrollkeeper-update -q; \
775fi; \
776%{nil}
777
778#-----------------------------------------------------------------
779# Compile GSettings schemas
780# requires: glib2 >= 1:2.26.0
781#
782%glib_compile_schemas() {{ \
783 umask 022; \
784 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
785};} \
786%{nil}
787
788#-----------------------------------------------------------------
789# post %install sequence:
790# - autodeps exceptions
791# - compress all man and info pages,
792# - strip all ELF executables and ELF shared objects if not %debug.
793# - compress kernel modules if any
794
795###################################################################
796# Requires/Provides automation
797# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
798#
799%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
800%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
801%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
802%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
803%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
804
805#%_noautocompressdoc %{nil}
806#
807%_missing_doc_files_terminate_build 1%{nil}
808%_unpackaged_files_terminate_build %{nil}
809# (X)emacs support
810%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
811%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
812%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
813
814%__php_provides %{nil}
815%__php_requires %{nil}
816%__perl_provides %{nil}
817%__perl_requires %{nil}
818%__mono_provides %{nil}
819%__mono_requires %{nil}
820
821# Perl specific macro definitions.
822%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
823%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
824%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
825%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
826%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
827%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
828
829# Ruby
830%__ruby /usr/bin/ruby
831%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
832%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
833%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
834%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
835%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
836%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
837%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
838%ruby_rdocdir /usr/share/rdoc
839%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
840%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
841%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
842
843%php_pear_dir /usr/share/pear
844%php_data_dir /usr/share/php
845%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
846%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
847%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
848
849# extract php/zend api versions
850%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
851%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
852%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
853%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
854%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
855%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
856%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
857%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
858# "_ts" if ZTS enabled, empty otherwise
859%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
860
861# helper macro
862%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
863
864# macros for public use
865# for php extensions (php-pecl)
866%requires_php_extension %{__php_api_requires modules_api php_api_version} \
867%{__php_api_requires zend_module_api} \
868%{__php_api_requires -v %php_major_version debug php_debug} \
869%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
870
871# for zend extensions
872%requires_zend_extension %{__php_api_requires zend_module_api} \
873%{__php_api_requires zend_extension_api} \
874%{__php_api_requires -v %php_major_version debug php_debug} \
875%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
876
877# for php pdo modules (php-pecl-PDO_*)
878%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
879
880# for using PHP post scripts. for PHP >= 5.0
881%php_webserver_restart \
882[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
883[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
884if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
885 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
886 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
887 %service -q php-fcgi restart \
888 fi \
889fi \
890if [ -x /etc/rc.d/init.d/php-fpm ]; then \
891 %service -q php-fpm restart \
892fi \
893%{nil}
894
895# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
896%php4_webserver_restart \
897[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
898[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
899if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
900 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
901 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
902 %service -q php-fcgi restart \
903 fi \
904fi \
905%{nil}
906
907# X.org helper macros
908%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
909%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
910
911%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
912%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
913%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
914%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
915%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
916# vim: '
917
918%requires_xorg_xserver_extension \
919%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
920%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
921%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
922%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
923%{nil}
924
925%requires_xorg_xserver_xinput \
926%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
927%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
928%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
929%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
930%{nil}
931
932%requires_xorg_xserver_font \
933%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
934%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
935%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
936%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
937%{nil}
938
939%requires_xorg_xserver_videodrv \
940%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
941%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
942%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
943%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
944%{nil}
945
946# TCL specific macro definitions.
947# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
948%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
949%tcl_sitearch %{_libdir}/tcl%{tcl_version}
950%tcl_sitelib %{_datadir}/tcl%{tcl_version}
951
952# Python specific macro definitions.
953# python main version
954%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
955
956# directories
957%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
958%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
959%py_scriptdir %{py_prefix}/share/python%{py_ver}
960%py_incdir /usr/include/python%{py_ver}
961%py_sitedir %{py_libdir}/site-packages
962%py_sitescriptdir %{py_scriptdir}/site-packages
963%py_dyndir %{py_libdir}/lib-dynload
964
965# pure python modules compilation
966%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
967
968%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
969
970# Software written in Python language require Python with main version
971%pyrequires_eq() Requires: %1
972
973# Python 3.x
974# python main version
975%__python3 python3
976%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
977
978# directories
979%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
980%py3_libdir %{expand:%%global py3_libdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('platstdlib'))" 2>/dev/null || echo ERROR)}%py3_libdir
981%py3_incdir %{expand:%%global py3_incdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('include'))" 2>/dev/null || echo ERROR)}%py3_incdir
982%py3_sitedir %{expand:%%global py3_sitedir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('platlib'))" 2>/dev/null || echo ERROR)}%py3_sitedir
983%py3_sitescriptdir %{expand:%%global py3_sitescriptdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('purelib'))" 2>/dev/null || echo ERROR)}%py3_sitescriptdir
984%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
985%py3_dyndir %{py3_libdir}/lib-dynload
986
987# pure python modules compilation
988%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
989
990%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
991
992
993# Hardlink binary identical .pyc and .pyo files
994%__spec_install_post_py_hardlink {\
995%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
996local a b c=0 t=0; \
997if [ -d "$RPM_BUILD_ROOT" ]; then \
998 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
999 while read a; do \
1000 b="${a%.pyc}.pyo"; \
1001 if cmp -s "$a" "$b"; then \
1002 ln -f "$a" "$b"; \
1003 c=$((c + 1)); \
1004 fi; \
1005 t=$((t + 1)); \
1006 done < __rpm_pyc; \
1007 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
1008 rm -f __rpm_pyc; \
1009fi; \
1010}; __spec_install_post_py_hardlink } }
1011
1012# remove python sources, so that check-files won't complain
1013%py_postclean() \
1014for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
1015 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
1016done \
1017%{nil}
1018
1019# depmod macro
1020%depmod() { \
1021umask 022; \
1022if [ -e /boot/System.map-%1 ]; then \
1023 /sbin/depmod -a -F /boot/System.map-%1 %1; \
1024else \
1025 if [ -e /boot/System.map ]; then \
1026 /sbin/depmod -a -F /boot/System.map %1; \
1027 else \
1028 /sbin/depmod -a %1; \
1029 fi \
1030fi; \
1031}
1032
1033# XMMS specific macros
1034%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1035%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1036%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1037%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1038%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1039%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1040%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1041%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1042%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1043%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1044
1045%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
1046
1047# user/group checking macros
1048#
1049# Usage:
1050# %userremove myuser
1051#
1052%userremove /usr/lib/rpm/user_group.sh user del
1053%groupremove /usr/lib/rpm/user_group.sh group del
1054#
1055# Usage:
1056# if %usertestrm myuser; then
1057# /usr/sbin/userdel -r myuser
1058# Note:
1059# use these macros only if you need to call userdel/groupdel with
1060# a non-standard option or take an extra action; otherwise use the
1061# %userremove/%groupremove macros
1062#
1063%usertestrm /usr/lib/rpm/user_group.sh user testrm
1064%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1065# user group membership management macros
1066#
1067# Usage:
1068# %addusertogroup [-q] myuser agroup
1069#
1070# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1071#
1072# Requirements:
1073# BuildRequires: rpmbuild(macros) >= 1.515
1074%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1075%{nil}
1076
1077# banner support (useful in {pre,post}{,un} and triggers)
1078#
1079# Usage:
1080# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1081# the banner text, the banner text
1082# the banner text, and following line
1083#EOF
1084# You can use any form of here-document, <<'EOF' <<-EOT will do.
1085# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1086#
1087# -a - append to the banner
1088# -e - send to stderr instead of stdout
1089# -n - no show banner (overrides -t)
1090# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1091# -o - show only once, i.e when package is installed for the first time
1092#
1093# Tests:
1094# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1095# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1096# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1097# rpm -E 'date | %banner -e banner' > m; sh -x m
1098# rpm -E 'date | %banner -o -e banner' > m; sh -x m
1099#
1100%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1101RPM_SCRIPTVERBOSITY=5 \
1102[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1103if [ -x /usr/bin/banner.sh ]; then \
1104 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1105else \
1106 CMD="cat%{-e: >&2}" \
1107fi \
1108eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1109%{nil}
1110
1111# useradd/groupadd macros
1112# Author: Elan Ruusamäe <glen@pld-linux.org>
1113#
1114# Usage:
1115# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1116# [-g initial_group] [-G group[,...]] login
1117#
1118# -u uid. REQUIRED
1119# -g gid/group. REQUIRED
1120# -s defaults to /bin/false
1121# -d defaults to /usr/share/empty
1122# -c No default
1123# -r is accepted but ignored (it's always set)
1124# -k skeleton dir. defaults to /usr/share/empty
1125# rpm specific flags
1126# -P package name. defaults to %{name}
1127#
1128%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1129%{!-u:%{error:useradd: Required argument -u missing}} \
1130%{!-g:%{error:useradd: Required argument -g missing}} \
1131%{!?1:%{error:useradd: Required parameter login missing}} \
1132if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1133 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1134 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1135 exit 1 \
1136 fi \
1137else \
1138 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1139 /usr/sbin/useradd \\\
1140 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1141 -u %{-u*} \\\
1142 -r \\\
1143 -d %{-d*}%{!-d:/usr/share/empty} \\\
1144 -s %{-s*}%{!-s:/bin/false} \\\
1145 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1146 -g %{-g*} \\\
1147 %{-M} \\\
1148 %{-G:-G %{-G*}} \\\
1149 %{expand:%{%{#}}} 1>&2 || exit $? \
1150 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1151fi;
1152# vim: "
1153
1154# Usage:
1155# %groupadd [-P package] [-g gid] group
1156#
1157# -g gid. REQUIRED
1158#
1159# Sample:
1160# %groupadd -P %{name}-base -g %{gid} %{name}
1161
1162%groupadd(g:P:rfo) \
1163%{!-g:%{error:groupadd: Required argument -g missing}} \
1164%{!?1:%{error:groupadd: Required parameter group missing}} \
1165if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1166 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1167 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1168 exit 1 \
1169 fi \
1170else \
1171 echo "Adding group %{1} GID=%{-g*}." \
1172 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1173 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1174fi;
1175
1176# webapp macros
1177# Author: Elan Ruusamäe <glen@pld-linux.org>
1178#
1179# The config is installed/removed inside trigger, this means that you can any
1180# time install apache1/apache/lighttpd package and the configuration file is
1181# updated. if you don't need the config for various reason for specific
1182# webserver, just remove the symlink from config directory using webapp
1183# program. the trigger will not recreate the symlink on upgrades. In other
1184# words the config is linked to webserver config directory on first install of
1185# PACKAGE or WEBSERVER.
1186#
1187# Add package's webserver config to webserver webapps dir.
1188# Usage:
1189# %webapp_register [-f] WEBSERVER WEBAPP
1190#
1191%webapp_register(f) \
1192%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1193if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1194 /usr/sbin/webapp register %1 %2\
1195fi\
1196# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1197if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1198 %{expand:%service -q %%1 reload}\
1199fi\
1200%{nil}
1201
1202# Remove package's config from webserver webapps dir.
1203# Usage:
1204# %webapp_register [-f] WEBSERVER WEBAPP
1205%webapp_unregister(f) \
1206%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1207# remove link if either of the packages are gone \
1208if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1209 /usr/sbin/webapp unregister %1 %2\
1210 %{expand:%service -q %%1 reload}\
1211fi \
1212%{nil}
1213
1214# service macro.
1215# Author: Elan Ruusamäe <glen@pld-linux.org>
1216#
1217# calls usual service restart on package %post, but skips the restart if
1218# administrator has disabled automatic service restarts in either global
1219# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1220#
1221# Usage:
1222# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1223#
1224# -q be silent when service isn't started (for scriplets restaring other package's services)
1225# -n NOOP mode, do not actually restart service
1226#
1227# Requirements:
1228# BuildRequires: rpmbuild(macros) >= 1.268
1229# Requires: rc-scripts
1230# -n option:
1231# BuildRequires: rpmbuild(macros) >= 1.450
1232%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
1233
1234
1235# Java macros. based on jpackage macros.java
1236#
1237# Root directory where all Java VMs/SDK/JREs are installed.
1238%_jvmdir %{_libdir}/jvm
1239
1240# Root directory where all Java VMs/SDK/JREs expose their jars
1241%_jvmjardir %{_libdir}/jvm-exports
1242
1243# Root directory for all Java VM/SDK/JRE's private things.
1244%_jvmprivdir %{_libdir}/jvm-private
1245
1246# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1247%_jvmlibdir %{_libdir}/jvm
1248
1249# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1250%_jvmdatadir %{_datadir}/jvm
1251
1252# Root directory for all configurations parts of Java VM/SDK/JRE's
1253%_jvmsysconfdir %{_sysconfdir}/jvm
1254
1255# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1256%_jvmcommonlibdir %{_libdir}/jvm-common
1257
1258# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1259%_jvmcommondatadir %{_datadir}/jvm-common
1260
1261# Root directory for all common configurations parts of Java VM/SDK/JRE's
1262%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1263
1264# Directory where arch-specific (JNI) version-independent jars are installed.
1265%_jnidir %{_libdir}/java
1266
1267
1268# JDK selection. Set this to name of the JDK implementation to use
1269# insead of the system default
1270#%use_jdk icedtea6
1271
1272# expands to the value with right jdk for BuildRequires header
1273# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1274# The requirement will not replace current 'default' JDK
1275%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1276
1277%buildrequires_jdk BuildRequires: %required_jdk
1278
1279%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1280
1281%_javasrcdir %{_usrsrc}/java
1282
1283%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1284%jar %{java_home}/bin/jar
1285%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1286%javac %{java_home}/bin/javac
1287%javadoc %{java_home}/bin/javadoc
1288
1289%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1290
1291%jpackage_script() \
1292install -d $RPM_BUILD_ROOT%{_bindir}\
1293cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1294#!/bin/sh\
1295#\
1296# %{name} script\
1297# JPackage Project <http://www.jpackage.org/>\
1298\
1299# Source functions library\
1300. %{_javadir}-utils/java-functions\
1301\
1302# Source system prefs\
1303if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1304 . %{_sysconfdir}/java/%{name}.conf\
1305fi\
1306\
1307# Source user prefs\
1308if [ -f $HOME/.%{name}rc ]; then\
1309 . $HOME/.%{name}rc\
1310fi\
1311\
1312# Configuration\
1313MAIN_CLASS=%1\
1314BASE_FLAGS=%2\
1315BASE_OPTIONS=%3\
1316BASE_JARS="%(echo %4 | tr ':' ' ')"\
1317\
1318# Set parameters\
1319set_jvm\
1320set_classpath $BASE_JARS\
1321set_flags $BASE_FLAGS\
1322set_options $BASE_OPTIONS\
1323\
1324# Let's start\
1325run "$@"\
1326EOF
1327
1328# jpackage 1.7
1329# Directory for maven depmaps
1330#
1331%_mavendepmapdir /etc/maven
1332%_mavendepmapfragdir /etc/maven/fragments
1333
1334#
1335# add_to_depmap adds an entry to the depmap. The arguments are:
1336#
1337# %1 the original groupid
1338# %2 the original artifact id
1339# %3 the version
1340# %4 the new groupid
1341# %5 the new artifactid
1342#
1343
1344%add_to_maven_depmap() \
1345install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1346cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1347<dependency>\
1348 <maven>\
1349 <groupId>%1</groupId>\
1350 <artifactId>%2</artifactId>\
1351 <version>%3</version>\
1352 </maven>\
1353 <jpp>\
1354 <groupId>%4</groupId>\
1355 <artifactId>%5</artifactId>\
1356 <version>%3</version>\
1357 </jpp>\
1358</dependency>\
1359\
1360EOF\
1361%{nil}
1362
1363#==============================================================================
1364#
1365# update_maven_depmap updates the main maven depmap
1366#
1367%update_maven_depmap() \
1368echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1369if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1370cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1371fi\
1372echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1373
1374# JAVA macros specific for PLD
1375
1376# Directory for tomcat context configuration files
1377%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
1378
1379# Tomcat cache path
1380%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1381
1382# Clear tomcat cache
1383# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1384#
1385# Usage:
1386# %%tomcat_clear_cache appname
1387#
1388# Call this script in %postun scriptlet. It will remove compiled jsps related to
1389# given app.
1390#
1391%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1392
1393# PEAR install macros
1394# Author: Elan Ruusamäe <glen@pld-linux.org>
1395#
1396# Usage:
1397# %%pear_package_setup ...
1398#
1399# -a # - also unpack SOURCE#. for PEAR bootstrapping
1400# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
1401# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1402# -D - pass -D to %setup (so the build dir is not removed)
1403# -c - register channel from local channel.xml file
1404# -d - pass -d arg to pearcmd
1405#
1406# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1407# destination hierarchy. you should copy the tree to buildroot after
1408# patching/reorganizing with %%pear_package_install.
1409#
1410# additionally BUILDROOT is stripped from files and files are converted to UNIX
1411# line endings.
1412#
1413# the pear install process output is recorded to install.log, you should put it
1414# to %%doc for later debug or just for information.
1415#
1416# additionally additional-packages.txt is produced if it was detected that the
1417# package has optional dependencies. the file format is suitable of displaying
1418# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1419# automatically added for this file.
1420
1421
1422# records install.log and transforms PEAR names to PLD Linux rpm package names.
1423%__pear_install_log \
1424tee install.log \
1425# make post message of optional packages \
1426grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,' > optional-packages.txt \
1427if [ -s optional-packages.txt ]; then \
1428 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1429else \
1430 rm -f optional-packages.txt \
1431fi \
1432%{nil}
1433
1434# Command invoking PEAR CLI
1435# Same as /usr/bin/pear, except we force GMT timezone
1436%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT %{php_pear_dir}/pearcmd.php
1437
1438%pear_install(a:d:n:zD) \
1439%__pear \\\
1440 -c %{builddir}/pearrc \\\
1441 -d doc_dir=/docs \\\
1442 -d temp_dir=/tmp \\\
1443 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1444 -d bin_dir=%{_bindir} \\\
1445 -d data_dir=%{php_pear_dir}/data \\\
1446 -d test_dir=%{php_pear_dir}/tests \\\
1447 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1448 install \\\
1449 --packagingroot=%{builddir} \\\
1450 --offline \\\
1451 --nodeps \\\
1452 %{-f:--force} \\\
1453 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1454 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1455%{nil}
1456
1457# The main macro.
1458# using this macro will append optional-packages.txt to the nocompressdoc list
1459# as it's displayed to user after package install. and adding additional gzip
1460# dep is just waste ;)
1461%pear_package_setup(a:d:n:zDc:) \
1462%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
1463%define builddir %{_builddir}/%{srcdir} \
1464%setup -q -c -T %{-D:-D} -n %{srcdir} \
1465%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
1466%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1467%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1468%pear_install \
1469%{-z:cd ..} \
1470%{__tar} --wildcards -zvxf %{S:0} package*.xml \
1471cat %{-z:$_N/}.install.log | %__pear_install_log \
1472%undos -f php,html,js,xml \
1473%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1474%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1475%{nil}
1476
1477# Copies extracted PEAR package structure and PEAR registry to buildroot.
1478# Author: Elan Ruusamäe <glen@pld-linux.org>
1479%pear_package_install() \
1480cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1481# tests should not be packaged \
1482%{__rm} -rf $RPM_BUILD_ROOT%{php_pear_dir}/tests \
1483# cleanup backups \
1484find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1485# help the developer out a little: \
1486if [ -f _noautoreq ]; then \
1487 echo "AutoReqdep detected:" \
1488 echo "_noautoreq $(cat _noautoreq)" \
1489fi \
1490%{nil}
1491
1492# Print optional package info for pear packages
1493# Author: Elan Ruusamäe <glen@pld-linux.org>
1494# Usage:
1495# %post -p <lua>
1496# %%pear_package_print_optionalpackages
1497#
1498# Requirements:
1499# BuildRequires: rpmbuild(macros) >= 1.571
1500%pear_package_print_optionalpackages \
1501f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1502if f then \
1503 for l in f:lines() do print(l); end \
1504end \
1505%{nil}
1506
1507
1508# Register OpenLDAP schema.
1509# Author: Elan Ruusamäe <glen@pld-linux.org>
1510#
1511# Usage:
1512# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1513#
1514# -d specify dependant schemas, separated by comma
1515#
1516%openldap_schema_register(d:) \
1517for schema in %*; do \
1518 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1519 %{__sed} -i -e " \
1520 /^include.*local.schema/{ \
1521 iinclude\\t $schema\
1522 } \
1523 " /etc/openldap/slapd.conf \
1524 fi \
1525done \
1526# enable dependant schemas \
1527if [ "%{-d*}" ]; then \
1528 %{__sed} -i -e ' \
1529 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1530 s/^#// \
1531 }' /etc/openldap/slapd.conf \
1532fi \
1533%{nil}
1534
1535# Unregister OpenLDAP schema.
1536# Author: Elan Ruusamäe <glen@pld-linux.org>
1537#
1538# Usage:
1539# %%openldap_schema_unregister %{schemadir}/horde.schema
1540#
1541%openldap_schema_unregister() \
1542for schema in %*; do \
1543 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1544 %{__sed} -i -e " \
1545 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1546 # for symmetry it would be nice if we disable enabled schemas in post, \
1547 # but we really can not do that, it would break something else. \
1548 " /etc/openldap/slapd.conf \
1549 fi \
1550done \
1551%{nil}
1552
1553%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1554
1555
1556# Build modules for kernels 2.6
1557# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1558#
1559# Usage:
1560# %build_kernel_modules -m <modules> -C <directory>
1561#
1562# remember that proper Makefile is still required
1563# Options:
1564# -m <modules> (required) -- comma-separated list of modules to save,
1565# without .ko extension, may be placed in subdirectory
1566# -C <directory> -- change to <directory> before doing anything
1567# -p <arg>, -P <arg> -- arguments passeed to make scripts
1568# -c -- do not execute make clean
1569# <additional arguments> -- all additional arguments will be passed to
1570# make modules
1571#
1572# Additional patching supported via here document. Try:
1573# %build_kernel_modules -m module <<'EOF'
1574# your patch script here
1575# EOF
1576# Don't use it unless patching depends on config options.
1577
1578# Developer note: don't touch it unless you know how to handle '\'.
1579# - \ in script expands to nothing
1580# - \\\ in script expands to \
1581# - \\\ inside definition expands to nothing
1582# - \\\\\\\ inside definition expands to \
1583# - in last line \ has to touch arguments so arguments passing
1584# in new lines (using \) will be supported
1585
1586%build_kernel_modules(p:P:m:C:c) \
1587%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1588 \
1589%define Opts \\\\\\\
1590%if "%{_target_base_arch}" != "%{_arch}" \\\
1591 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1592 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
1593 %else \\\
1594 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1595 %endif \\\
1596%else \\\
1597 CC="%{kgcc}" \\\
1598%endif \
1599%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1600 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1601 \
1602%{?-C:cd %{-C*}} \
1603compile() { \
1604 local L="<" PATCH_SH; \
1605 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1606 set -e -x \
1607 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1608 \
1609for cfg in ${cfgs:-dist}; do \
1610 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1611 \
1612 rm -rf o \
1613 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
1614 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1615 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1616 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1617 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
1618 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1619 else \
1620 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1621 fi \
1622 \
1623 set +x \
1624 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1625 set -x \
1626 \
1627 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
1628 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1629 %{-p*} %{-P*} \\\
1630 %{MakeOpts} \
1631 %else \
1632 install -d o/include/config \
1633 touch o/include/config/MARKER \
1634 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
1635 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1636 %endif \
1637 \
1638 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1639 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
1640 ${1+"$@"} \\\
1641 M=$PWD %{MakeOpts}} \
1642 \
1643 %{__make} -C %{_kernelsrcdir} modules \\\
1644 ${1+"$@"} \\\
1645 M=$PWD %{MakeOpts} \
1646 \
1647 for MODULE in {%{-m*},}; do \
1648 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1649 done \
1650done \
1651%{?-C:cd -} \
1652} \
1653compile %{*}\
1654%{nil}
1655
1656
1657# Install kernel modules built by %build_kernel_modules
1658# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1659#
1660# Usage:
1661# %install_kernel_modules -m <modules> -d <directory>
1662#
1663# Options:
1664# -m <modules> (required) -- comma-separated list of modules to install,
1665# without .ko extension, may be placed in subdirectory
1666# -d <directory> (required) -- in what subdirectory modules should be
1667# installed (eg. misc, kernel/drivers/net)
1668# -s <suffix> -- suffix to use when installing modules, useful when module
1669# with same name exists in kernel already
1670# -n <file> -- name of modprobe config file to use (without .conf extension)
1671# for defining aliases, only useful with -s
1672
1673%install_kernel_modules(m:d:s:n:) \
1674%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1675%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1676%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1677 \
1678%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1679%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1680 \
1681__install_kernel_modules() { \
1682local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1683 \
1684for MODULE in {%{-m*},}; do \
1685 [ -n "${MODULE}" ] || continue \
1686 for cfg in ${cfgs:-dist}; do \
1687 [ "$cfg" = smp ] && suf=smp || suf= \
1688 MNAME=${MODULE##*/} \
1689 install -D ${MODULE}-$cfg.ko \\\
1690 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1691 %{?-s:install -d %{ModprobeD}$suf \
1692 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1693 >> %{ModprobeD}$suf/%{-n*}.conf} \
1694 done \
1695done \
1696} \
1697__install_kernel_modules \
1698%{nil}
1699
1700# patchset macros
1701# Author: Elan Ruusamäe <glen@pld-linux.org>
1702#
1703# Usage:
1704# %patchset_source -f <seq(1) format> <start> [<end>]
1705# %patchset_patch <start> [<end>]
1706#
1707# If <end> is omited, it is assumed to be <start>.
1708#
1709# For example in preamble:
1710# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1711# and in %prep:
1712# %patchset_patch 33 44
1713
1714# generate SourceX urls from range START STOP
1715# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1716# The sources start from 10000
1717%patchset_source(f:b:) %(
1718 base=%{-b*}%{!-b*:10000};
1719 start=$(expr $base + %1);
1720 end=$(expr $base + %{?2}%{!?2:%{1}});
1721 # we need to call seq twice as it doesn't allow two formats
1722 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1723 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1724 paste %{tmpdir}/__ps{1,2};
1725 rm -f %{tmpdir}/__ps{1,2};
1726) \
1727%{nil}
1728
1729# apply sources from %patchset_source
1730# -p specify -pX for %patch line
1731# -b base offset: defaults to 10000
1732%patchset_patch(f:p:b:) %(
1733 base=%{-b*}%{!-b*:10000};
1734 start=$(expr $base + %1);
1735 end=$(expr $base + %{?2}%{!?2:%{1}});
1736 echo ": patchset_patch %1%{?2: to %2}";
1737 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1738) \
1739%{nil}
1740
1741# browser plugins v2
1742# Author: Elan Ruusamäe <glen@pld-linux.org>
1743#
1744# Usage:
1745# %browser_plugins_add_browser <name> -p <plugindir>
1746#
1747# <name> (required) -- name of the browser. usually %{name}.
1748# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1749# -b -- default blacklists
1750# -a <arch> override arch
1751#
1752# Example:
1753# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1754
1755%_browserpluginsconfdir /etc/browser-plugins
1756%_browserpluginsdir %{_libdir}/browser-plugins
1757%update_browser_plugins /usr/sbin/update-browser-plugins || :
1758
1759%browser_plugins_add_browser(p:b:a:) \
1760 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1761 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1762 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1763 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1764 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1765 %{-b:cat >> $blacklist_file %{-b*}} \
1766%{nil}
1767
1768# Helper for LUA.
1769# split string separated by space into quoted list
1770#
1771# Author: Elan Ruusamäe <glen@pld-linux.org>
1772#
1773# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1774%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1775
1776# adjust /etc/shells by adding and removing shells from there
1777# Author: Elan Ruusamäe <glen@pld-linux.org>
1778#
1779# Usage:
1780# %post -p <lua>
1781# %lua_add_etc_shells /bin/sh /bin/pdksh
1782#
1783# %preun -p <lua>
1784# if arg[2] == 0 then
1785# %lua_remove_etc_shells /bin/bash /bin/rbash
1786# end
1787#
1788# Requirements:
1789# BuildRequires: rpmbuild(macros) >= 1.462
1790#
1791
1792%lua_add_etc_shells() \
1793t = {}\
1794f = io.open("/etc/shells", "r")\
1795if f then\
1796 for l in f:lines() do t[l]=l; end\
1797 f:close()\
1798end\
1799for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1800 if not t[s] then\
1801 print("Adding "..s.." to /etc/shells")\
1802 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1803 end\
1804end\
1805%{nil}
1806
1807%lua_remove_etc_shells() \
1808t = {}\
1809f = io.open("/etc/shells", "r")\
1810if f then\
1811 for l in f:lines() do t[l]=l; end\
1812 f:close()\
1813end\
1814for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1815 print("Removing "..l.." from /etc/shells")\
1816 t[l] = nil\
1817end\
1818s=""\
1819for _, l in pairs(t) do\
1820 s=s..l.."\\n"\
1821end\
1822io.open("/etc/shells", "w"):write(s)\
1823%{nil}
1824
1825# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1826#
1827# Author: Elan Ruusamäe <glen@pld-linux.org>
1828#
1829# Usage:
1830# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1831# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1832#
1833# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1834#
1835# Requirements:
1836# BuildRequires: rpmbuild(macros) >= 1.429
1837#
1838%add_etc_shells(p) %{-p:<lua>}\
1839%{expand:%%lua_add_etc_shells %*}\
1840%{nil}
1841
1842%remove_etc_shells(p) %{-p:<lua>}\
1843%{-p:if arg[2] == 0 then}\
1844%{expand:%%lua_remove_etc_shells %*}\
1845%{-p:end} \
1846%{nil}
1847
1848# Check syntax for Python files
1849#
1850# Author: Elan Ruusamäe <glen@pld-linux.org>
1851# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1852#
1853# Usage:
1854# %py_lint src
1855#
1856# Requirements:
1857# BuildRequires: python
1858# BuildRequires: rpmbuild(macros) >= 1.602
1859
1860%py_lint() \
1861__py_lint() { \
1862find "$@" -type f -name '*.py' | python -c ' \
1863import sys \
1864import compiler \
1865\
1866found = err = 0\
1867for f in sys.stdin: \
1868 fd = open(f.rstrip()) \
1869 c = fd.read() \
1870 fd.close() \
1871 found = found + 1 \
1872 try: \
1873 compiler.parse(c) \
1874 except SyntaxError, e: \
1875 print "py_lint: %s: %s" % (f.rstrip(), e) \
1876 err = err + 1\
1877\
1878if not found:\
1879 print >> sys.stderr, "\\npy_lint: ERROR: No files processed.\\n" \
1880 sys.exit(1) \
1881elif err: \
1882 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1883 sys.exit(1) \
1884else: \
1885 print >> sys.stderr, "py_lint: %d files scanned, found no syntax errors." % found \
1886' \
1887}; __py_lint %* \
1888%{nil}
1889
1890# Undos files
1891#
1892# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1893# Author: Elan Ruusamäe <glen@pld-linux.org>
1894#
1895# Usage:
1896# %undos list_of_files
1897# %undos -f EXT[,EXT]
1898# %undos -i -f EXT[,EXT]
1899#
1900# -f EXT[,EXT] - find(1) files by extensions
1901# -i - case insensitive file search
1902#
1903# Example:
1904# Un-DOS all *.js, *.css files
1905# %undos -f js,css
1906# Un-DOS all *.js, *.JS files
1907# %undos -f js -i
1908# undos all Makefiles
1909# %{__find} -name Makefile | xargs %undos
1910#
1911# Requirements:
1912# BuildRequires: sed >= 4.0
1913# BuildRequires: rpmbuild(macros) >= 1.565
1914
1915# NB: make sure this macro stays on one line
1916# NB: make sure it includes newline escape
1917%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1918%{nil}
1919
1920# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1921#
1922# Author: Elan Ruusamäe <glen@pld-linux.org>
1923#
1924# Usage:
1925# -a NAME -- add command named NAME
1926# -d NAME -- remove command named NAME
1927# -f FILE -- specify plugin configuration FILE to extract command definition from
1928#
1929# Sample:
1930# %triggerin -- nagios-nrpe
1931# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1932#
1933# %triggerun -- nagios-nrpe
1934# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1935#
1936# Requirements:
1937# Requires: grep
1938# Requires: sed >= 4.0
1939# BuildRequires: rpmbuild(macros) >= 1.552
1940%nagios_nrpe(a:d:c:f:) {\
1941 m=$(md5sum < /etc/nagios/nrpe.cfg); \
1942 %{-a:# on -a and config exists \
1943 if [ -f /etc/nagios/nrpe.cfg ]; then \
1944 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1945 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
1946 fi; \
1947 fi;} \
1948 %{-d:# on package remove, -d and config exists \
1949 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1950 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
1951 fi;} \
1952 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1953 %service -q nrpe restart; \
1954 fi; \
1955}%{nil}
1956
1957# Import or update Cacti template.
1958#
1959# Author: Elan Ruusamäe <glen@pld-linux.org>
1960#
1961# Usage:
1962# %cacti_import_template XMLFILE
1963# XMLFILE -- XML template to import
1964#
1965# Sample:
1966# %post
1967# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1968#
1969# Requires: cacti >= 0.8.7e-8
1970# BuildRequires: rpmbuild(macros) >= 1.554
1971
1972%cacti_import_template() {\
1973/usr/share/cacti/cli/import_template.php --filename=%1 || :; \
1974}%{nil}
1975
1976# pre/post script for -upstart subpackages
1977#
1978# Author: Jacek Konieczny <jajcus@jajcus.net>
1979#
1980# Usage:
1981# %upstart_post service_name
1982# %upstart_postun service_name
1983#
1984# Sample:
1985# %post upstart
1986# %upstart_post %{name}
1987#
1988# %postun upstart
1989# %upstart_postun %{name}
1990#
1991# Requirements:
1992# BuildRequires: rpmbuild(macros) >= 1.560
1993# Requires: rc-scripts >= 0.4.3
1994
1995# migrate from init script to upstart job
1996%upstart_post() \
1997 if [ -f /var/lock/subsys/%1 ]; then \
1998 /sbin/service --no-upstart %1 stop \
1999 /sbin/service %1 start \
2000 fi
2001
2002# restart the job after upgrade or migrate to init script on removal
2003# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
2004# at this point
2005%upstart_postun() \
2006 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
2007 /sbin/initctl stop %1 >/dev/null 2>&1 \
2008 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
2009 fi
2010
2011# Haskell Macros
2012# BuildRequires: rpmbuild(macros) >= 1.608
2013%ghcdir ghc-%(/usr/bin/ghc --numeric-version 2>/dev/null || echo ERROR)
2014
2015# update /usr/lib*/ghc-*/package.conf.d/package.cache
2016# Requires: ghc
2017# BuildRequires: rpmbuild(macros) >= 1.607
2018#
2019%ghc_pkg_recache() {{ \
2020 umask 022; \
2021 /usr/bin/ghc-pkg recache; \
2022};} \
2023%{nil}
2024
2025# EOF
This page took 0.048213 seconds and 4 git commands to generate.